From 24a300ffa4aad25811ac0d5be6dc7408fd720910 Mon Sep 17 00:00:00 2001
From: Draekko <draekko.software+exiv2@gmail.com>
Date: Sat, 24 Jun 2017 10:18:33 -0400
Subject: [PATCH] New branch for split XMP SDK and C++11 changes

---
 CMakeLists.txt                                   |   89 +-
 Makefile                                         |    8 +-
 README-CMAKE                                     |    1 -
 config/CMakeChecks.txt                           |    8 +-
 config/Makefile.in                               |    8 +-
 config/aclocal.m4                                |  982 ++++++++++
 config/config.mk.in                              |   16 +-
 config/configure.ac                              |   37 +-
 contrib/cmake/msvc/ReadMe.txt                    |    1 -
 contrib/organize/helpers.cpp                     |    2 +-
 include/exiv2/basicio.hpp                        |    5 +-
 include/exiv2/datasets.hpp                       |    4 +
 include/exiv2/exiv2.hpp                          |    2 +-
 include/exiv2/image.hpp                          |    6 +-
 include/exiv2/metadatum.hpp                      |    4 +
 include/exiv2/properties.hpp                     |    4 +
 include/exiv2/tags.hpp                           |    4 +
 include/exiv2/value.hpp                          |   52 +
 include/exiv2/{xmp.hpp => xmp_exiv2.hpp}         |   10 +-
 samples/CMakeLists.txt                           |   11 +-
 samples/Makefile                                 |    2 +-
 samples/metacopy.cpp                             |    4 +
 src/CMakeLists.txt                               |   47 +-
 {xmpsdk/src => src}/MD5.cpp                      |   25 +-
 {xmpsdk/include => src}/MD5.h                    |    8 +-
 src/Makefile                                     |    9 +-
 src/actions.cpp                                  |   14 +-
 src/actions.hpp                                  |   40 +
 src/asfvideo.cpp                                 |   11 +
 src/bmpimage.cpp                                 |   11 +
 src/convert.cpp                                  |   16 +-
 src/cr2image.cpp                                 |   13 +
 src/crwimage.cpp                                 |   25 +
 src/crwimage_int.hpp                             |    8 +
 src/epsimage.cpp                                 |    9 +
 src/exif.cpp                                     |   29 +
 src/exiv2.cpp                                    |    2 +-
 src/gifimage.cpp                                 |    9 +
 src/image.cpp                                    |   38 +
 src/iptc.cpp                                     |    8 +
 src/jp2image.cpp                                 |    9 +
 src/jpgimage.cpp                                 |   24 +
 src/matroskavideo.cpp                            |    9 +
 src/mrwimage.cpp                                 |    9 +
 src/orfimage.cpp                                 |   13 +
 src/pgfimage.cpp                                 |   10 +
 src/pngchunk.cpp                                 |    5 +
 src/pngimage.cpp                                 |    9 +
 src/preview.cpp                                  |    4 +
 src/properties.cpp                               |    4 +-
 src/psdimage.cpp                                 |    9 +
 src/quicktimevideo.cpp                           |   10 +
 src/rafimage.cpp                                 |    9 +
 src/riffvideo.cpp                                |    9 +
 src/rw2image.cpp                                 |    9 +
 src/tgaimage.cpp                                 |    9 +
 src/tiffcomposite.cpp                            |   84 +
 src/tiffcomposite_int.hpp                        |   11 +
 src/tifffwd_int.hpp                              |    4 +
 src/tiffimage.cpp                                |   30 +
 src/tiffimage_int.hpp                            |   14 +
 src/tiffvisitor.cpp                              |   28 +
 src/version.cpp                                  |    2 +-
 src/webpimage.cpp                                |    9 +
 src/{xmp.cpp => xmp_exiv2.cpp}                   |   68 +-
 src/xmpsidecar.cpp                               |   11 +-
 xmpsdk/CMakeLists.txt                            |   44 -
 xmpsdk/Readme.txt                                |   42 +
 xmpsdk/include/TXMPIterator.hpp                  |  235 ---
 xmpsdk/include/TXMPMeta.hpp                      | 1803 ------------------
 xmpsdk/include/TXMPUtils.hpp                     |  965 ----------
 xmpsdk/include/XMP.incl_cpp                      |   63 -
 xmpsdk/include/XMPSDK.hpp                        |   89 -
 xmpsdk/include/XMP_Const.h                       | 1330 --------------
 xmpsdk/include/XMP_Environment.h                 |  164 --
 xmpsdk/include/XMP_Version.h                     |   45 -
 xmpsdk/include/client-glue/TXMPIterator.incl_cpp |  226 ---
 xmpsdk/include/client-glue/TXMPMeta.incl_cpp     |  935 ----------
 xmpsdk/include/client-glue/TXMPUtils.incl_cpp    |  493 -----
 xmpsdk/include/client-glue/WXMPFiles.hpp         |  167 --
 xmpsdk/include/client-glue/WXMPIterator.hpp      |   83 -
 xmpsdk/include/client-glue/WXMPMeta.hpp          |  622 -------
 xmpsdk/include/client-glue/WXMPUtils.hpp         |  322 ----
 xmpsdk/include/client-glue/WXMP_Common.hpp       |  123 --
 xmpsdk/ren-lnx.sh                                |    4 +
 xmpsdk/ren-mac.sh                                |    4 +
 xmpsdk/ren-win.bat                               |    2 +
 xmpsdk/src/ExpatAdapter.cpp                      |  504 -----
 xmpsdk/src/ExpatAdapter.hpp                      |   50 -
 xmpsdk/src/Makefile                              |  153 --
 xmpsdk/src/ParseRDF.cpp                          | 1296 -------------
 xmpsdk/src/UnicodeConversions.cpp                | 1665 -----------------
 xmpsdk/src/UnicodeConversions.hpp                |  121 --
 xmpsdk/src/UnicodeInlines.incl_cpp               |  129 --
 xmpsdk/src/WXMPIterator.cpp                      |  188 --
 xmpsdk/src/WXMPMeta.cpp                          | 1310 -------------
 xmpsdk/src/WXMPUtils.cpp                         |  626 -------
 xmpsdk/src/XMLParserAdapter.hpp                  |  140 --
 xmpsdk/src/XML_Node.cpp                          |  463 -----
 xmpsdk/src/XMPCore_Impl.cpp                      | 1468 ---------------
 xmpsdk/src/XMPCore_Impl.hpp                      |  534 ------
 xmpsdk/src/XMPIterator.cpp                       |  736 --------
 xmpsdk/src/XMPIterator.hpp                       |  148 --
 xmpsdk/src/XMPMeta-GetSet.cpp                    | 1212 ------------
 xmpsdk/src/XMPMeta-Parse.cpp                     | 1291 -------------
 xmpsdk/src/XMPMeta-Serialize.cpp                 | 1342 --------------
 xmpsdk/src/XMPMeta.cpp                           | 1649 -----------------
 xmpsdk/src/XMPMeta.hpp                           |  418 -----
 xmpsdk/src/XMPUtils-FileInfo.cpp                 | 1346 --------------
 xmpsdk/src/XMPUtils.cpp                          | 2135 ----------------------
 xmpsdk/src/XMPUtils.hpp                          |  221 ---
 xmpsdk/src/XMP_BuildInfo.h                       |   22 -
 112 files changed, 1880 insertions(+), 27042 deletions(-)
 rename include/exiv2/{xmp.hpp => xmp_exiv2.hpp} (98%)
 rename {xmpsdk/src => src}/MD5.cpp (92%)
 rename {xmpsdk/include => src}/MD5.h (83%)
 rename src/{xmp.cpp => xmp_exiv2.cpp} (94%)
 delete mode 100644 xmpsdk/CMakeLists.txt
 create mode 100644 xmpsdk/Readme.txt
 delete mode 100644 xmpsdk/include/TXMPIterator.hpp
 delete mode 100644 xmpsdk/include/TXMPMeta.hpp
 delete mode 100644 xmpsdk/include/TXMPUtils.hpp
 delete mode 100644 xmpsdk/include/XMP.incl_cpp
 delete mode 100644 xmpsdk/include/XMPSDK.hpp
 delete mode 100644 xmpsdk/include/XMP_Const.h
 delete mode 100644 xmpsdk/include/XMP_Environment.h
 delete mode 100644 xmpsdk/include/XMP_Version.h
 delete mode 100644 xmpsdk/include/client-glue/TXMPIterator.incl_cpp
 delete mode 100644 xmpsdk/include/client-glue/TXMPMeta.incl_cpp
 delete mode 100644 xmpsdk/include/client-glue/TXMPUtils.incl_cpp
 delete mode 100644 xmpsdk/include/client-glue/WXMPFiles.hpp
 delete mode 100644 xmpsdk/include/client-glue/WXMPIterator.hpp
 delete mode 100644 xmpsdk/include/client-glue/WXMPMeta.hpp
 delete mode 100644 xmpsdk/include/client-glue/WXMPUtils.hpp
 delete mode 100644 xmpsdk/include/client-glue/WXMP_Common.hpp
 create mode 100755 xmpsdk/ren-lnx.sh
 create mode 100755 xmpsdk/ren-mac.sh
 create mode 100644 xmpsdk/ren-win.bat
 delete mode 100644 xmpsdk/src/ExpatAdapter.cpp
 delete mode 100644 xmpsdk/src/ExpatAdapter.hpp
 delete mode 100644 xmpsdk/src/Makefile
 delete mode 100644 xmpsdk/src/ParseRDF.cpp
 delete mode 100644 xmpsdk/src/UnicodeConversions.cpp
 delete mode 100644 xmpsdk/src/UnicodeConversions.hpp
 delete mode 100644 xmpsdk/src/UnicodeInlines.incl_cpp
 delete mode 100644 xmpsdk/src/WXMPIterator.cpp
 delete mode 100644 xmpsdk/src/WXMPMeta.cpp
 delete mode 100644 xmpsdk/src/WXMPUtils.cpp
 delete mode 100644 xmpsdk/src/XMLParserAdapter.hpp
 delete mode 100644 xmpsdk/src/XML_Node.cpp
 delete mode 100644 xmpsdk/src/XMPCore_Impl.cpp
 delete mode 100644 xmpsdk/src/XMPCore_Impl.hpp
 delete mode 100644 xmpsdk/src/XMPIterator.cpp
 delete mode 100644 xmpsdk/src/XMPIterator.hpp
 delete mode 100644 xmpsdk/src/XMPMeta-GetSet.cpp
 delete mode 100644 xmpsdk/src/XMPMeta-Parse.cpp
 delete mode 100644 xmpsdk/src/XMPMeta-Serialize.cpp
 delete mode 100644 xmpsdk/src/XMPMeta.cpp
 delete mode 100644 xmpsdk/src/XMPMeta.hpp
 delete mode 100644 xmpsdk/src/XMPUtils-FileInfo.cpp
 delete mode 100644 xmpsdk/src/XMPUtils.cpp
 delete mode 100644 xmpsdk/src/XMPUtils.hpp
 delete mode 100644 xmpsdk/src/XMP_BuildInfo.h

diff --git a/CMakeLists.txt b/CMakeLists.txt
index 130cb56e..8c19d590 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -17,6 +17,13 @@ if( EXISTS "${CMAKE_SOURCE_DIR}/include/exiv2/exv_conf.h"  )
 endif()
 ##
 
+if( EXISTS "${CMAKE_SOURCE_DIR}/xmpsdk/include"  )
+    set( ADOBE_XMP_SDK_INCLUDE ON )
+else()
+    set( ADOBE_XMP_SDK_INCLUDE OFF )
+    message( FATAL_ERROR "Missing Adobe XMP SDK include files. Setup cannot proceed." )
+endif()
+
 CMAKE_MINIMUM_REQUIRED( VERSION 3.1.0 )
 PROJECT( exiv2 )
 
@@ -38,9 +45,12 @@ SET( GENERIC_LIB_VERSION    "26.0.0" )
 SET( GENERIC_LIB_SOVERSION  "26" )
 
 # options and their default values
+OPTION( EXIV2_CPP_STANDARD           "Set the C++ Standard to compile with"                 11  )
+OPTION( EXIV2_CPP_STANDARD_REQUIRED  "Set C++ Standard to required"                         ON  )
+OPTION( EXIV2_CPP_EXTENSION          "Set C++ Extensions to required"                       OFF )
+OPTION( EXIV2_ENABLE_VERBOSITY       "Enable verbosity"                                     OFF )
 OPTION( EXIV2_ENABLE_SHARED        "Build exiv2 as a shared library (dll)"                 ON  )
 OPTION( EXIV2_ENABLE_XMP           "Build with XMP metadata support"                       ON  )
-OPTION( EXIV2_ENABLE_LIBXMP        "Build a static convenience Library for XMP"            ON  )
 OPTION( EXIV2_ENABLE_PNG           "Build with png support (requires libz)"                ON  )
 OPTION( EXIV2_ENABLE_NLS           "Build native language support (requires gettext)"      ON  )
 OPTION( EXIV2_ENABLE_PRINTUCS2     "Build with Printucs2"                                  ON  )
@@ -61,9 +71,28 @@ ELSE()
     SET ( EXIV2_ENABLE_DYNAMIC_RUNTIME OFF )
 ENDIF()
 
+SET ( CMAKE_VERBOSE_MAKEFILE ${EXIV2_ENABLE_VERBOSITY} )
+IF ( NOT ${EXIV2_CPP_STANDARD} )
+    SET ( EXIV2_CPP_STANDARD 11 )
+ENDIF ()
+
 # set include path for FindXXX.cmake files
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/config/")
 
+IF ( WIN32 OR MINGW OR MSVC )
+    SET( XMPLIB_EXT lib )
+ELSE()
+    SET( XMPLIB_EXT a )
+ENDIF()
+
+IF ( EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/libXMPCore.${XMPLIB_EXT}" AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/libXMPFiles.${XMPLIB_EXT}" )
+    MESSAGE( STATUS "Has xmp sdk library files" )
+    SET ( EXV_HAS_XMP_SDK_LIBS ON )
+ELSE()
+    MESSAGE( STATUS "Doesn't have xmp sdk library files" )
+    SET ( EXV_HAS_XMP_SDK_LIBS OFF )
+ENDIF()
+
 IF( MINGW OR UNIX )
     IF ( CMAKE_CXX_COMPILER STREQUAL "g++" OR CMAKE_C_COMPILER STREQUAL "gcc" )
         ADD_DEFINITIONS(-Wall
@@ -87,14 +116,16 @@ IF( MINGW OR UNIX )
 
     message(STATUS Compiler: ${COMPILER} " Major:" ${GCC_MAJOR} " Minor:" ${GCC_MINOR})
 
-    IF ( CYGWIN OR ( ${GCC_MAJOR} GREATER 5 ))
-        ADD_DEFINITIONS( -std=gnu++98 ) # to support snprintf
-    ELSE()
-        ADD_DEFINITIONS( -std=c++98 )
-    ENDIF()
-
 ENDIF( MINGW OR UNIX )
 
+set( CMAKE_CXX_STANDARD ${EXIV2_CPP_STANDARD} )
+set( CMAKE_CXX_STANDARD_REQUIRED ${EXIV2_CPP_STANDARD_REQUIRED} )
+set( CMAKE_CXX_EXTENSIONS ${EXIV2_CPP_EXTENSION} )
+
+IF ( ${EXIV2_CPP_STANDARD} LESS 98 AND ${EXIV2_CPP_STANDARD} GREATER 10  )
+    ADD_DEFINITIONS( -DEXV_USING_CPP_ELEVEN=1  )
+ENDIF()
+
 IF( EXIV2_ENABLE_COMMERCIAL )
     SET (EXIV2_ENABLE_LENSDATA OFF)
     SET (EXIV2_ENABLE_NLS OFF)
@@ -130,38 +161,40 @@ SET( INSTALL_TARGET_STANDARD_ARGS
      ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
 )
 
-##
-# add sources from XMPSDK directory
-# this needs to be done here to be visible to xmpsdk, src and sample sub directories
-SET( XMPSRC ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/ExpatAdapter.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/MD5.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/ParseRDF.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/UnicodeConversions.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/WXMPIterator.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/WXMPMeta.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/WXMPUtils.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/XML_Node.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/XMPCore_Impl.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/XMPIterator.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/XMPMeta-GetSet.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/XMPMeta-Parse.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/XMPMeta-Serialize.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/XMPMeta.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/XMPUtils-FileInfo.cpp
-            ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/src/XMPUtils.cpp
+IF ( WIN32 OR MINGW OR MSVC )
+    SET( XMPLIB_EXT lib )
+ELSE()
+    SET( XMPLIB_EXT a )
+ENDIF()
+
+IF ( EXV_HAS_XMP_SDK_LIBS )
+    SET ( XMPLIBS ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/libXMPCore.${XMPLIB_EXT}
+                  ${CMAKE_CURRENT_SOURCE_DIR}/xmpsdk/libXMPFiles.${XMPLIB_EXT}
 )
+ENDIF()
+
+##
+# Adobe XMP SDK definitions
+IF( MSVC OR WIN32 OR MINGW)
+  ADD_DEFINITIONS( -DXMP_WinBuild=1 -DWIN_ENV=1 )
+ELSEIF( UNIX AND APPLE) 
+  ADD_DEFINITIONS( -DXMP_MacBuild=1 -DMAC_ENV=1 )
+ELSE()
+  ADD_DEFINITIONS( -DXMP_UNIXBuild=1 -DUNIX_ENV=1 )
+ENDIF()
 
 # the following lines need to be added to circumvent the error in xmpsdk\src\MD5.h
 IF( ${EXV_HAVE_STDINT_H} )
     ADD_DEFINITIONS( -DEXV_HAVE_STDINT_H )
 ENDIF( ${EXV_HAVE_STDINT_H} )
 
-ADD_SUBDIRECTORY( xmpsdk )
 ADD_SUBDIRECTORY( src )
 
+IF ( EXV_HAS_XMP_SDK_LIBS )
 IF( EXIV2_ENABLE_BUILD_SAMPLES )
     ADD_SUBDIRECTORY( samples )
 ENDIF( EXIV2_ENABLE_BUILD_SAMPLES )
+ENDIF()
 
 IF( EXIV2_ENABLE_BUILD_PO )
     ADD_SUBDIRECTORY( po )
@@ -169,8 +202,10 @@ ENDIF( EXIV2_ENABLE_BUILD_PO )
 
 ##
 # tests
+IF ( EXV_HAS_XMP_SDK_LIBS )
 ADD_CUSTOM_TARGET(tests       COMMAND env EXIV2_BINDIR="${CMAKE_BINARY_DIR}"/bin make tests       WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}" )
 ADD_CUSTOM_TARGET(geotag-test COMMAND env EXIV2_BINDIR="${CMAKE_BINARY_DIR}"/bin make geotag-test WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}" )
+ENDIF()
 
 ##
 # http://dev.exiv2.org/boards/3/topics/1364
diff --git a/Makefile b/Makefile
index efca81b1..7b1a78f2 100644
--- a/Makefile
+++ b/Makefile
@@ -52,11 +52,11 @@
 SHELL = /bin/sh
 ENABLE_XMP = 1
 
-.PHONY: all doc config samples xmpsdk                \
+.PHONY: all doc config samples                 \
         mostlyclean clean distclean maintainer-clean \
         install uninstall tests teste testv
 
-all install: config/config.mk xmpsdk
+all install: config/config.mk
 	cd src && $(MAKE) $(MAKECMDGOALS)
 	cd po && $(MAKE) $(MAKECMDGOALS)
 
@@ -133,15 +133,11 @@ configure:
 config:
 	cd config && $(MAKE) -f config.make $(MAKECMDGOALS)
 
-xmpsdk: config/config.mk
-	if test "x$(ENABLE_XMP)" = "x1"; then cd xmpsdk/src && $(MAKE) $@; fi;
-
 mostlyclean clean: config/config.mk
 	cd src && $(MAKE) $(MAKECMDGOALS)
 	cd doc && $(MAKE) $(MAKECMDGOALS)
 	cd samples && $(MAKE) $(MAKECMDGOALS)
 	cd test && $(MAKE) $(MAKECMDGOALS)
-	cd xmpsdk/src && $(MAKE) $(MAKECMDGOALS)
 	cd config && $(MAKE) -f config.make $(MAKECMDGOALS)
 	cd po && $(MAKE) $(MAKECMDGOALS)
 	rm -f include/exiv2/exv_conf.h
diff --git a/README-CMAKE b/README-CMAKE
index 438f87cb..7e184248 100644
--- a/README-CMAKE
+++ b/README-CMAKE
@@ -88,7 +88,6 @@ Specific Exiv2 options :
 
 -DEXIV2_ENABLE_SHARED        : Build exiv2 as a shared library (dll).            [default=on ]
 -DEXIV2_ENABLE_XMP           : Build with XMP metadata support.                  [default=on ]
--DEXIV2_ENABLE_LIBXMP        : Build a static convenience Library for XMP.       [default=on ]
 -DEXIV2_ENABLE_PNG           : Build with png support (requires libz).           [default=on ]
 -DEXIV2_ENABLE_NLS           : Build native language support (requires gettext). [default=on ]
 -DEXIV2_ENABLE_PRINTUCS2     : Build with Printucs2.                             [default=on ]
diff --git a/config/config.mk.in b/config/config.mk.in
index 8d920647..619cecd0 100644
--- a/config/config.mk.in
+++ b/config/config.mk.in
@@ -92,11 +92,21 @@ endif
 ENABLE_XMP = @ENABLE_XMP@
 
 ifdef ENABLE_XMP
-        XMPSDK_LIBRARY = xmpsdk
         XMPSDK_DIR = $(top_srcdir)/xmpsdk
         XMPSDK_CPPFLAGS = -I$(XMPSDK_DIR)/include
-        XMPSDK_LDFLAGS = -L$(XMPSDK_DIR)/src
-        XMPSDK_LIBS = -l$(XMPSDK_LIBRARY)
+        XMPSDK_LDFLAGS = -L$(XMPSDK_DIR)
+        XMPSDK_LIBRARIES = -lXMPCore -lXMPFiles
+        XMPSDK_STATIC_LIBS = $(XMPSDK_DIR)/libXMPCore.a $(XMPSDK_DIR)/libXMPFiles.a
+        ifeq ($(OS),Windows_NT)
+                XMPSDK_CPPFLAGS += -DWIN_ENV=1 -DXMP_WinBuild=1
+        else
+                UNAME_S := $(shell uname -s)
+                ifeq ($(UNAME_S),Linux)
+                        XMPSDK_CPPFLAGS += -DUNIX_ENV=1 -DXMP_UNIXBuild=1
+                else
+                        XMPSDK_CPPFLAGS += -DMAC_ENV=1 -DXMP_MacBuild=1
+                endif
+        endif
 else
         # Enable additional warnings. XMP Toolkit doesn't compile
         # with these.
diff --git a/config/configure.ac b/config/configure.ac
index 9d325624..e9507753 100644
--- a/config/configure.ac
+++ b/config/configure.ac
@@ -16,6 +16,9 @@ AC_CONFIG_SRCDIR([src/exif.cpp])
 AC_CONFIG_HEADER([./config/config.h])
 AC_CONFIG_AUX_DIR([./config])
 
+AC_CHECK_FILES([${srcdir}/xmpsdk/include/XMP.hpp], , [echo "Did not find XMP SDK headers"; exit -1])
+AC_CHECK_FILES([${srcdir}/xmpsdk/libXMPCore.a ${srcdir}/xmpsdk/libXMPFiles.a], , [echo "Did not find XMP SDK static lib"; exit -1])
+
 # ---------------------------------------------------------------------------
 # Checks for programs.
 # ---------------------------------------------------------------------------
@@ -23,6 +26,7 @@ AC_CONFIG_AUX_DIR([./config])
 ac_cv_prog_cxx_g=no
 AC_PROG_CXX
 AC_PROG_CXXCPP
+AX_CXX_COMPILE_STDCXX(11, noext, optional)
 # Don't use -g to compile C code
 ac_cv_prog_cc_g=no
 AC_PROG_CC
@@ -145,12 +149,6 @@ AC_ARG_ENABLE(commercial,
 AC_MSG_RESULT($COMMERCIAL_VERSION)
 AC_SUBST(COMMERCIAL_VERSION,$COMMERCIAL_VERSION)
 
-AC_MSG_CHECKING([whether to enable XMP support (requires expat)])
-AC_ARG_ENABLE(xmp,
-    [  --disable-xmp           do not compile XMP support and the XMP Toolkit ],
-    USE_XMP_TOOLKIT=$enableval, USE_XMP_TOOLKIT=yes)
-AC_MSG_RESULT($USE_XMP_TOOLKIT)
-
 AC_MSG_CHECKING([whether to compile with video support])
 AC_ARG_ENABLE(video,
     [  --enable-video          compile with video support ],
@@ -266,8 +264,6 @@ AC_ARG_WITH(expat,
   fi
 ])
 
-ENABLE_XMP=
-if test "$USE_XMP_TOOLKIT" = "yes"; then
     # Check for expat library
     found_expat=yes
     EXPAT_CPPFLAGS=
@@ -286,17 +282,13 @@ if test "$USE_XMP_TOOLKIT" = "yes"; then
         PTHREAD="-lpthread"
     fi
     if test "$with_expat" = "no" -o "$found_expat" = "no"; then
-        AC_MSG_ERROR(either specify a valid expat installation with --with-expat=DIR or disable XMP support with --disable-xmp)
+    AC_MSG_ERROR(either specify a valid expat installation with --with-expat=DIR)
     fi
-    AC_DEFINE(HAVE_XMP_TOOLKIT,1)
-    ENABLE_XMP=1
     AC_SUBST(EXPAT_CPPFLAGS)
     AC_SUBST(EXPAT_LDFLAGS)
     AC_SUBST(EXPAT_LIBS)
     AC_CHECK_LIB(pthread, pthread_create, [PTHREAD_LIBS+=-lpthread])
     AC_SUBST(PTHREAD_LIBS)
-fi
-AC_SUBST(ENABLE_XMP)
 
 CPPFLAGS=${_cppflags}
 LDFLAGS=${_ldflags}
@@ -355,6 +347,13 @@ AC_DEFUN([AX_GCC_VERSION], [
   AC_SUBST([GCC_VERSION])
 ])
 
+AC_ARG_ENABLE(stdcpp11,
+    [  --disable-stdcpp11    do not use the c++11 standard ],
+    STDCPP11_SUPPORT=$enableval, STDCPP11_SUPPORT=$visibility)
+AC_MSG_RESULT($STDCPP11_SUPPORT)
+if test "$STDCPP11_SUPPORT" = "yes"; then
+    CPPFLAGS="${CPPFLAGS} -std=c++11 -DEXV_USING_CPP_ELEVEN"
+else
 # 1188 v0.26 uses c++98
 # 1188 v0.27 should have an option to specify versions such as c++11
 case "$host_os" in
@@ -371,6 +370,7 @@ case "$host_os" in
         fi
     ;;
 esac
+fi
 
 # ---------------------------------------------------------------------------
 # Create output files.
@@ -426,17 +426,6 @@ yes) echo "-- Nikon lens database............ YES" ;;
 *)   echo "-- Nikon lens database............ NO" ;;
 esac
 
-case "$USE_XMP_TOOLKIT" in
-yes) echo "-- XMP metadata support........... YES" ;;
-*)   echo "-- XMP metadata support........... NO"
-     echo ""
-     echo "Expat is required for XMP support. Make sure the Expat header"
-     echo "files are installed and use --with-expat=DIR if it is in a"
-     echo "non-standard location. You can get Expat from"
-     echo "http://expat.sourceforge.net/"
-     echo "" ;;
-esac
-
 case "x$ENABLE_VIDEO" in
 x1)  echo "-- Video support.................. YES" ;;
 *)   echo "-- Video support.................. NO"
diff --git a/contrib/organize/helpers.cpp b/contrib/organize/helpers.cpp
index 7f08e429..6ca7caaf 100644
--- a/contrib/organize/helpers.cpp
+++ b/contrib/organize/helpers.cpp
@@ -35,7 +35,7 @@
 #include <exiv2/exif.hpp>
 #include <exiv2/iptc.hpp>
 #include <exiv2/tags.hpp>
-//#include <exiv2/xmp.hpp>
+//#include <exiv2/xmp_exiv2.hpp>
 #include <cassert>
 #include <sstream>
 #include <ctime>
diff --git a/include/exiv2/basicio.hpp b/include/exiv2/basicio.hpp
index 95713bfc..9824936c 100644
--- a/include/exiv2/basicio.hpp
+++ b/include/exiv2/basicio.hpp
@@ -67,8 +67,11 @@ namespace Exiv2 {
     class EXIV2API BasicIo {
     public:
         //! BasicIo auto_ptr type
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<BasicIo> AutoPtr;
+#else
         typedef std::auto_ptr<BasicIo> AutoPtr;
-
+#endif
         //! Seek starting positions
         enum Position { beg, cur, end };
 
diff --git a/include/exiv2/datasets.hpp b/include/exiv2/datasets.hpp
index 46a323c5..f03c17ac 100644
--- a/include/exiv2/datasets.hpp
+++ b/include/exiv2/datasets.hpp
@@ -280,7 +280,11 @@ namespace Exiv2 {
     class EXIV2API IptcKey : public Key {
     public:
         //! Shortcut for an %IptcKey auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<IptcKey> AutoPtr;
+#else
         typedef std::auto_ptr<IptcKey> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
diff --git a/include/exiv2/exiv2.hpp b/include/exiv2/exiv2.hpp
index 9930b8b3..d4cc566e 100644
--- a/include/exiv2/exiv2.hpp
+++ b/include/exiv2/exiv2.hpp
@@ -70,7 +70,7 @@
 #include "exiv2/types.hpp"
 #include "exiv2/value.hpp"
 #include "exiv2/version.hpp"
-#include "exiv2/xmp.hpp"
+#include "exiv2/xmp_exiv2.hpp"
 #include "exiv2/xmpsidecar.hpp"
 
 #endif                                  // #ifndef EXIV2_HPP_
diff --git a/include/exiv2/image.hpp b/include/exiv2/image.hpp
index 4040d524..76e37736 100644
--- a/include/exiv2/image.hpp
+++ b/include/exiv2/image.hpp
@@ -31,7 +31,7 @@
 #include "basicio.hpp"
 #include "exif.hpp"
 #include "iptc.hpp"
-#include "xmp.hpp"
+#include "xmp_exiv2.hpp"
 
 // + standard includes
 #include <string>
@@ -82,7 +82,11 @@ namespace Exiv2 {
     class EXIV2API Image {
     public:
         //! Image auto_ptr type
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<Image> AutoPtr;
+#else
         typedef std::auto_ptr<Image> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
diff --git a/include/exiv2/metadatum.hpp b/include/exiv2/metadatum.hpp
index 4e7b2f5c..d520e297 100644
--- a/include/exiv2/metadatum.hpp
+++ b/include/exiv2/metadatum.hpp
@@ -60,7 +60,11 @@ namespace Exiv2 {
     class EXIV2API Key {
     public:
         //! Shortcut for a %Key auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<Key> AutoPtr;
+#else
         typedef std::auto_ptr<Key> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
diff --git a/include/exiv2/properties.hpp b/include/exiv2/properties.hpp
index 415ab4ab..f451a96c 100644
--- a/include/exiv2/properties.hpp
+++ b/include/exiv2/properties.hpp
@@ -249,7 +249,11 @@ namespace Exiv2 {
     class EXIV2API XmpKey : public Key {
     public:
         //! Shortcut for an %XmpKey auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<XmpKey> AutoPtr;
+#else
         typedef std::auto_ptr<XmpKey> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
diff --git a/include/exiv2/tags.hpp b/include/exiv2/tags.hpp
index 0c1b487a..dd746cc1 100644
--- a/include/exiv2/tags.hpp
+++ b/include/exiv2/tags.hpp
@@ -150,7 +150,11 @@ namespace Exiv2 {
     class EXIV2API ExifKey : public Key {
     public:
         //! Shortcut for an %ExifKey auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<ExifKey> AutoPtr;
+#else
         typedef std::auto_ptr<ExifKey> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
diff --git a/include/exiv2/value.hpp b/include/exiv2/value.hpp
index 64a8ca7f..a9ba7ccc 100644
--- a/include/exiv2/value.hpp
+++ b/include/exiv2/value.hpp
@@ -63,7 +63,11 @@ namespace Exiv2 {
     class EXIV2API Value {
     public:
         //! Shortcut for a %Value auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<Value> AutoPtr;
+#else
         typedef std::auto_ptr<Value> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
@@ -265,7 +269,11 @@ namespace Exiv2 {
     class EXIV2API DataValue : public Value {
     public:
         //! Shortcut for a %DataValue auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<DataValue> AutoPtr;
+#else
         typedef std::auto_ptr<DataValue> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
@@ -352,7 +360,11 @@ namespace Exiv2 {
     class EXIV2API StringValueBase : public Value {
     public:
         //! Shortcut for a %StringValueBase auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<StringValueBase> AutoPtr;
+#else
         typedef std::auto_ptr<StringValueBase> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
@@ -434,7 +446,11 @@ namespace Exiv2 {
     class EXIV2API StringValue : public StringValueBase {
     public:
         //! Shortcut for a %StringValue auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<StringValue> AutoPtr;
+#else
         typedef std::auto_ptr<StringValue> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
@@ -466,7 +482,11 @@ namespace Exiv2 {
     class EXIV2API AsciiValue : public StringValueBase {
     public:
         //! Shortcut for a %AsciiValue auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<AsciiValue> AutoPtr;
+#else
         typedef std::auto_ptr<AsciiValue> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
@@ -553,7 +573,11 @@ namespace Exiv2 {
         }; // class CharsetInfo
 
         //! Shortcut for a %CommentValue auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<CommentValue> AutoPtr;
+#else
         typedef std::auto_ptr<CommentValue> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
@@ -640,7 +664,11 @@ namespace Exiv2 {
     class EXIV2API XmpValue : public Value {
     public:
         //! Shortcut for a %XmpValue auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<XmpValue> AutoPtr;
+#else
         typedef std::auto_ptr<XmpValue> AutoPtr;
+#endif
 
         //! XMP array types.
         enum XmpArrayType { xaNone, xaAlt, xaBag, xaSeq };
@@ -731,7 +759,11 @@ namespace Exiv2 {
     class EXIV2API XmpTextValue : public XmpValue {
     public:
         //! Shortcut for a %XmpTextValue auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<XmpTextValue> AutoPtr;
+#else
         typedef std::auto_ptr<XmpTextValue> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
@@ -813,7 +845,11 @@ namespace Exiv2 {
     class EXIV2API XmpArrayValue : public XmpValue {
     public:
         //! Shortcut for a %XmpArrayValue auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<XmpArrayValue> AutoPtr;
+#else
         typedef std::auto_ptr<XmpArrayValue> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
@@ -910,7 +946,11 @@ namespace Exiv2 {
     class EXIV2API LangAltValue : public XmpValue {
     public:
         //! Shortcut for a %LangAltValue auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<LangAltValue> AutoPtr;
+#else
         typedef std::auto_ptr<LangAltValue> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
@@ -998,7 +1038,11 @@ namespace Exiv2 {
     class EXIV2API DateValue : public Value {
     public:
         //! Shortcut for a %DateValue auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<DateValue> AutoPtr;
+#else
         typedef std::auto_ptr<DateValue> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
@@ -1099,7 +1143,11 @@ namespace Exiv2 {
     class EXIV2API TimeValue : public Value {
     public:
         //! Shortcut for a %TimeValue auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<TimeValue> AutoPtr;
+#else
         typedef std::auto_ptr<TimeValue> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
@@ -1255,7 +1303,11 @@ namespace Exiv2 {
     class ValueType : public Value {
     public:
         //! Shortcut for a %ValueType\<T\> auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<ValueType<T> > AutoPtr;
+#else
         typedef std::auto_ptr<ValueType<T> > AutoPtr;
+#endif
 
         //! @name Creators
         //@{
